% DM TP10 : Arbre de decision
% Auteurs : florian boitrel - Maxime Chambreuil
% Date : 31 Mai 2003

close all
clear all

%%%%%%%%%%%%%%%%
% INITIALISATION
m1=0;
m2=3;
varcov=[1 0;0 1];
X1 = genererMatNormale(150,2,[m1,m2],varcov);

m1=-1;
m2=1;
varcov=[1 0;0 1];
X2 = genererMatNormale(150,2,[m1,m2],varcov);

% Donnees d apprentissage
X=[ X1(1:50,:) ; X2(1:50,:) ];
yapp=zeros(50,1);
yapp(51:100)=1;

% Affichage
figure;
plot(X1(:,1),X1(:,2),'b+');
hold on;
plot(X2(:,1),X2(:,2),'r+');
hold on;

% Donnes de test
xtest = [X1(51:100,:);X2(51:100,:)];
ytest= zeros(50,1);
ytest(51:100)=1;

% Donnees de validation
xval= [X1(101:150,:);X2(101:150,:)];
yval= zeros(50,1);
yval(51:100)=1;

%%%%%%%%%%%%%%%
% ARBRE COMPLET
% Nombre minimal d individus dans un noeud
S=1;
% si on met 'on' un entier  chaque noeud pour l'ordre d'lagage des noeuds
% a utiliser avec treepruning
T = treeclass(X,yapp,'splitmin',S,'method','classification','splitcriterion','gdi','prune','off');
y=treetesting(T,xtest);
% Treetesting retourne 1 ou 2
y = y-1;
bienclasseComplet = length(find(y==ytest))

%%%%%%%%%%%%%%%%%%
% ELAGAGE Niveau 1
T2=treepruning(T,'level',1);
y=treetesting(T2,xtest);
% Treetesting retourne 1 ou 2
y = y-1;
bienclasseElague = length(find(y==ytest))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Avec les donnes de validation
Ndepart=100;
[Nopt,Topt]=optimisationArret(X,yapp,xval,yval,Ndepart);
y=treetesting(Topt,xtest);
% Treetesting retourne 1 ou 2
y = y-1;
bienclasseAvecValidation = length(find(y==ytest))

%%%%%%%%%%%
% AFFICHAGE

% Affichage des points de test
plot(xtest(find(y==0),1),xtest(find(y==0),2),'b*');hold on;
plot(xtest(find(y==1),1),xtest(find(y==1),2),'r*');hold on;

h = 20;
taille = 100;
x1 = linspace(min(X(:,1)),max(X(:,1)),taille);
x2 = linspace(min(X(:,2)),max(X(:,2)),taille); 
methode = 3;
afficheFrontiere(x1,x2,X,yapp, h,methode);
% legend('Classe 0','Classe 1','Points de test en classe 0','Points de test en classe 1','Frontiere de decision');
% title(strcat('Optimisation arrt, Nopt = ',num2str(Nopt)));
hold on;

% On rajoute un point dans la classe 0 en disant qu il est dans la classe 1
%  pour tester la stabilite de l algo
[a,b]=ginput(1);
yapp=[yapp ; 1];
X=[X ; a b];
afficheFrontiere(x1,x2,X,yapp, h,methode);hold on;
plot(a,b,'kd');
legend('Classe 0','Classe 1','Points de test en classe 0','Points de test en classe 1','Nouveau point','Nouvelle frontiere','Frontiere de decision');
title('Illustration de la stabilit des arbres de dcision'); 
