% DM TP 10 : Arbre de decision
% Auteurs : florian boitrel et Maxime Chambreuil
% Date : 31 Mai 2003
%
% [Nopt,Topt]=optimisationArret(Xapp,Yapp,Xval,Yval,Ndepart)
%
% EN ENTREE :
% Xapp : matrice des points d apprentissage
% Yapp : vecteur des classes d appartenance pour les points d app ( 0 ou 1 )
% Xval : matrice des points de validation
% Yval : vecteur des classes d appartenance pour les points de validation ( 0 ou 1 )
% Ndepart : nombre maximal de points dans une classe impure
%
% EN SORTIE :
% Nopt : Nombre optimum de points dans une classe impure
% Topt : Arbre optimum pour Nopt
%

function [Nopt,Topt]=optimisationArret(Xapp,Yapp,Xval,Yval,Ndepart)

erreurmin=inf;

for i=Ndepart:-1:1

 T=treeclass(Xapp,Yapp,'splitmin',i,'method','classification','splitcriterion','gdi','prune','off');
 Yfit=treetesting(T,Xval);
 erreur=sum(abs(Yfit-Yval)/2);

 if (erreur<erreurmin)
   erreurmin=erreur;
   Nopt=i;
   Topt=T;
   y=Yfit-1;
 end

end
